## spml-g95 0.7.1

=== Makefile ===
# Makefile for spmodel library

include Config.mk

all:
	cd src; $(MAKE)
	cd spmfrt; $(MAKE) $@
	if [ X$(MPIFC) != X ]; then \
		cd src-mpi; $(MAKE) ;\
	fi

install: all
	cd src; $(MAKE) $@
	cd spmfrt; $(MAKE) $@
	if [ X$(MPIFC) != X ]; then \
		cd src-mpi; $(MAKE) $@ ;\
	fi

html:
	cd doc; $(MAKE)
	cd doc; $(MAKE) install

test: check

check:
	cd test ; $(MAKE) test

clean: clean.local
	( cd src; $(MAKE) $@ )
	( cd src-mpi; $(MAKE) $@ )
	( cd spmfrt; $(MAKE) $@ )
	( cd demo; $(MAKE) $@ )
	( cd test; $(MAKE) $@ )
	( cd doc; $(MAKE) $@ )
	( cd supplemental; $(MAKE) $@ )

clean.local:
	-rm *.bak *~

distclean: clean
	-rm -r html
	-rm -f config.status chkfort.cfg chkgmake.cfg
	-rm -f config.cache config.log Config.mk
	@echo ""
	@echo "    Removing Config.mk,"
	@echo "      you should rerun ./configure to build spmodel library."
	@echo ""

# cl:
# 	@cvs2cl --help > /dev/null 2>&1 || \
# 	    echo -e \
# 		"\n" \
# 		"    cvs2cl is not found.\n" \
# 		"    Please get from http://www.red-bean.com/cvs2cl/\n"
# 	@cvs2cl --help > /dev/null 2>&1 && \
# 	    echo -e \
# 		"This file is generated automatically by\n" \
# 		"\n" \
# 		"    cvs2cl.pl -r -b -t --fsf -w --header <This header>\n" \
# 		"\n" \
# 		`cvs2cl --version` "\n" \
# 		"This script is available from "      \
# 		"http://www.red-bean.com/cvs2cl/\n\n" \
# 		    | cvs2cl -r -b -t --fsf -w --header -
# 	rm ChangeLog.bak
# 	@echo -e "\n" "ChangeLog is Updated." "\n"

=== test/Makefile ===
# Makefile for spmodel library

include ../Config.mk

MISCDIRS=at_galerkin_module misc

NMPIDIRS=lumatrix ae_module at_module au_module aq_module \
	ee_module esc_module et_module eq_module ef_module \
	eee_module eea_module tee_module \
	w_module wa_module wt_module \
	wu_module wtu_module wq_module wtq_module \
	l_module la_module w_zonal_module wa_zonal_module wt_zonal_module \
	ae_module_fftj ee_module_fftj et_module_fftj \
	eea_module_fftj tee_module_fftj \
	w_module_sjpack wa_module_sjpack wt_module_sjpack wq_module_sjpack \
	wtq_module_sjpack \
	l_module_sjpack la_module_sjpack \
	w_zonal_module_sjpack wa_zonal_module_sjpack

MPIDIRS=eee_mpi_module w_mpi_module wa_mpi_module wt_mpi_module wq_mpi_module wtq_mpi_module

ifeq (X$(EIGMATRIXLIB),X)
	SUBDIRS1 :=$(NMPIDIRS)
else
	SUBDIRS1 :=$(NMPIDIRS) eigmatrix
endif

ifeq ($(CUDA),yes)
	SUBDIRS := $(SUBDIRS1) w_module_sjpack_cuda wa_module_sjpack_cuda wt_module_sjpack_cuda
else
	SUBDIRS := $(SUBDIRS1)
endif


ifeq (X$(MPIFC),X)
	TESTDIRS := $(SUBDIRS) $(MISCDIRS)
else
	TESTDIRS := $(SUBDIRS) $(MISCDIRS) $(MPIDIRS)
endif

all: clean

test:
	for i in $(TESTDIRS) ; do \
	  cd $$i || exit 1 ; \
	  $(MAKE) test || exit 1 ;  \
	  cd ../ ; \
	done
	@echo ""
	@echo ""
	@echo " *** Compilation and installation are succeeded !! *** "
	@echo ""
	@echo ""

clean: clean.local clean.subdirs

clean.subdirs:
	@for i in $(TESTDIRS) ; do \
	  ( cd $$i && $(MAKE) clean ) ; \
	done

clean.local:
	-rm -f $(MODS) *.o work.pc* *~ *.bak *.out *.nc

=== test/ae_module/Makefile ===
# Makefile for spmodel library
#
# $Id: Makefile,v 1.5 2009-01-16 16:23:04 uwabami Exp $
# 

include ../../Config.mk

SPMFRT=$(DEST_BIN)/spmfrt

all: clean

clean:
	-rm -f $(MODS) *.o work.pc* *~ *.bak *.out *.nc

test:	ae_test_base1d.out ae_test_base2d.out \
	ae_test_intavr.out ae_test_interpolate.out
	./ae_test_base1d.out
	./ae_test_base2d.out
	./ae_test_intavr.out
	./ae_test_interpolate.out

.SUFFIXES: .f90 .out

.f90.out:
	$(FC) -I../../src  $(SYSFFLAGS) -o $@ $< -L../../src -l$(LIBNAME) $(SYSLDFLAGS) $(SYSLDLIBS)

=== test/at_galerkin_module/Makefile ===
# Makefile for spmodel library
#
# $Id: Makefile,v 1.3 2009-01-16 16:23:04 uwabami Exp $
# 

include ../../Config.mk

SPMFRT=$(DEST_BIN)/spmfrt

all: clean

clean:
	-rm -f $(MODS) *.o work.pc* *~ *.bak *.out *.nc

test:	at_ap_galerkin_DN_test1d.out at_ap_galerkin_DN_test2d.out \
	at_aq_galerkin_RR_test1d.out at_ab_galerkin_ND_test1d.out \
	at_aq_galerkin_RR_test2d.out at_ab_galerkin_ND_test2d.out \
	at_aq_galerkin_RS_test1d.out at_ad_galerkin_DD_test1d.out \
	at_aq_galerkin_SR_test1d.out at_ad_galerkin_DD_test2d.out \
	at_aq_galerkin_SS_test1d.out at_af_galerkin_MM_test1d.out \
	at_aq_galerkin_SS_test2d.out at_af_galerkin_MM_test2d.out \
	at_av_galerkin_NN_test1d.out at_ah_galerkin_MMex_test1.out \
	at_av_galerkin_NN_test2d.out
	./at_ap_galerkin_DN_test1d.out
	./at_ap_galerkin_DN_test2d.out
	./at_aq_galerkin_RR_test1d.out
	./at_ab_galerkin_ND_test1d.out
	./at_aq_galerkin_RR_test2d.out
	./at_ab_galerkin_ND_test2d.out
	./at_aq_galerkin_RS_test1d.out
	./at_ad_galerkin_DD_test1d.out
	./at_aq_galerkin_SR_test1d.out
	./at_ad_galerkin_DD_test2d.out
	./at_aq_galerkin_SS_test1d.out
	./at_af_galerkin_MM_test1d.out
	./at_aq_galerkin_SS_test2d.out
	./at_af_galerkin_MM_test2d.out
	./at_av_galerkin_NN_test1d.out
	./at_ah_galerkin_MMex_test1.out
	./at_av_galerkin_NN_test2d.out

.SUFFIXES: .f90 .out

.f90.out:
	$(FC) -I../../src  $(SYSFFLAGS) -o $@ $< -L../../src -l$(LIBNAME) $(SYSLDFLAGS) $(SYSLDLIBS)

=== test/au_module/Makefile ===
# Makefile for spmodel library

include ../../Config.mk

SPMFRT=$(DEST_BIN)/spmfrt

all: clean

clean:
	-rm -f $(MODS) *.o work.pc* *~ *.bak *.out *.nc

test:	au_test_base1d.out au_test_base2d.out \
	au_test_intavr.out au_test_weight.out \
	au_test_boundary1d.out \
	au_test_boundary2d.out
	./au_test_base1d.out
	./au_test_base2d.out
	./au_test_intavr.out
	./au_test_weight.out
	./au_test_boundary1d.out
	./au_test_boundary2d.out

.SUFFIXES: .f90 .out

.f90.out:
	$(FC) -I../../src  $(SYSFFLAGS) -o $@ $< -L../../src -l$(LIBNAME) $(SYSLDFLAGS) $(SYSLDLIBS)

=== test/eea_module_fftj/Makefile ===
# Makefile for spmodel library

include ../../Config.mk

SPMFRT=$(DEST_BIN)/spmfrt

all: clean

clean:
	-rm -f $(MODS) *.o work.pc* *~ *.bak *.out *.nc

test:	eea_module_fftj_transform_test.out eea_module_fftj_derivative_test.out \
	eea_module_fftj_jacobian_test.out eea_module_fftj_jacobianZ_test.out \
	eea_module_fftj_intavr_test.out eea_module_fftj_spectrum_test.out \
	eea_module_fftj_interpolate_test.out
	./eea_module_fftj_transform_test.out 
	./eea_module_fftj_derivative_test.out 
	./eea_module_fftj_jacobian_test.out
	./eea_module_fftj_jacobianZ_test.out
	./eea_module_fftj_intavr_test.out
	./eea_module_fftj_spectrum_test.out
	./eea_module_fftj_interpolate_test.out

.SUFFIXES: .f90 .out

.f90.out:
	$(FC) -I../../src  $(SYSFFLAGS) -o $@ $< -L../../src -l$(LIBNAME) $(SYSLDFLAGS) $(SYSLDLIBS)

=== test/ef_module/Makefile ===
# Makefile for spmodel library

include ../../Config.mk

SPMFRT=$(DEST_BIN)/spmfrt

all: clean

clean:
	-rm -f $(MODS) *.o work.pc* *~ *.bak *.out *.nc

test:	ef_module_base_test.out \
	ef_module_deriv_test.out \
	ef_module_integral_test.out \
	ef_module_interpolate_test.out 
	./ef_module_base_test.out 
	./ef_module_deriv_test.out
	./ef_module_integral_test.out  
	./ef_module_interpolate_test.out 

.SUFFIXES: .f90 .out

.f90.out:
	$(FC) -I../../src  $(SYSFFLAGS) -o $@ $< -L../../src -l$(LIBNAME) $(SYSLDFLAGS) $(SYSLDLIBS)

=== test/eq_module/Makefile ===
# Makefile for spmodel library

include ../../Config.mk

SPMFRT=$(DEST_BIN)/spmfrt

all: clean

clean:
	-rm -f $(MODS) *.o work.pc* *~ *.bak *.out *.nc *.mod

.SUFFIXES: .f90 .out

test:	eq_test_transform.out eq_test_derivative.out \
	eq_test_jacobian.out eq_test_LaplaInv.out \
	eq_test_boundary.out eq_test_Vor2Strum.out eq_test_intavr.out 
	./eq_test_transform.out
	./eq_test_derivative.out
	./eq_test_jacobian.out
	./eq_test_boundary.out
	./eq_test_LaplaInv.out
	./eq_test_Vor2Strum.out
	./eq_test_intavr.out

.f90.out:
	$(FC) -I../../src  $(SYSFFLAGS) -o $@ $< -L../../src -l$(LIBNAME) $(SYSLDFLAGS) $(SYSLDLIBS)

=== test/lumatrix/Makefile ===
# Makefile for spmodel library
#
# $Id: Makefile,v 1.3 2009-01-16 16:22:59 uwabami Exp $
# 

include ../../Config.mk

SPMFRT=$(DEST_BIN)/spmfrt

all: clean

clean:
	-rm -f $(MODS) *.o work.pc* *~ *.bak *.out *.nc

test:	lumatrix_test.out
	./lumatrix_test.out

.SUFFIXES: .f90 .out

.f90.out:
	$(FC) -I../../src  $(SYSFFLAGS) -o $@ $< -L../../src -l$(LIBNAME) $(SYSLDFLAGS) $(SYSLDLIBS)

=== test/tee_module/Makefile ===
# Makefile for spmodel library

include ../../Config.mk

SPMFRT=$(DEST_BIN)/spmfrt

all: clean

clean:
	-rm -f $(MODS) *.o work.pc* *~ *.bak *.out *.nc

test:	tee_module_base_test.out \
	tee_module_deriv_test.out \
	tee_module_integral_test.out \
	tee_module_interpolate_test.out \
	tee_module_torpol_test.out  \
	tee_module_spectrum_test.out \
	tee_module_BoundariesTau_test.out  \
	tee_module_BoundariesGrid_test.out \
	tee_module_TorvelbcTau_test.out  \
	tee_module_TorvelbcGrid_test.out \
	tee_module_PolvelbcGrid_test.out \
	tee_module_PolvelbcCheb_test.out \
	tee_module_TormagbcTau_test.out  \
	tee_module_TormagbcGrid_test.out \
	tee_module_PolmagbcTau_test.out  \
	tee_module_PolmagbcGrid_test.out
	./tee_module_base_test.out
	./tee_module_deriv_test.out
	./tee_module_integral_test.out
	./tee_module_interpolate_test.out
	./tee_module_torpol_test.out
	./tee_module_spectrum_test.out
	./tee_module_BoundariesTau_test.out
	./tee_module_BoundariesGrid_test.out
	./tee_module_TorvelbcTau_test.out
	./tee_module_TorvelbcGrid_test.out
	./tee_module_PolvelbcGrid_test.out
	./tee_module_PolvelbcCheb_test.out
	./tee_module_TormagbcTau_test.out
	./tee_module_TormagbcGrid_test.out
	./tee_module_PolmagbcTau_test.out
	./tee_module_PolmagbcGrid_test.out

.SUFFIXES: .f90 .out

.f90.out:
	$(FC) -I../../src  $(FFLAGS) $(SYSFFLAGS) -o $@ $< -L../../src -l$(LIBNAME) $(SYSLDFLAGS) $(SYSLDLIBS)

=== test/w_module_sjpack_cuda/Makefile ===
# Makefile for spmodel library

include ../../Config.mk

SPMFRT=$(DEST_BIN)/spmfrt

all: clean

clean:
	-rm -f $(MODS) *.o work.pc* *~ *.bak *.out *.nc

test:	w_base_module_sjpack_cuda_test.out \
	w_deriv_module_sjpack_cuda_test.out \
	w_interpolate_module_sjpack_cuda_test.out \
	w_integral_module_sjpack_cuda_test.out \
	w_spectrum_module_sjpack_cuda_test.out
	./w_base_module_sjpack_cuda_test.out
	./w_deriv_module_sjpack_cuda_test.out
	./w_interpolate_module_sjpack_cuda_test.out 
	./w_integral_module_sjpack_cuda_test.out 
	./w_spectrum_module_sjpack_cuda_test.out

.SUFFIXES: .f90 .out

.f90.out:
	$(FC) -I../../src  $(SYSFFLAGS) -o $@ $< -L../../src -l$(LIBNAME) $(SYSLDFLAGS) $(SYSLDLIBS)

=== test/wa_mpi_module/Makefile ===
# Makefile for spmodel library

include ../../Config.mk

SPMFRT=$(DEST_BIN)/spmfrt

clean:
	-rm -f $(MODS) *.o work.pc* *~ *.bak *.out *.nc

test:	wa_base_mpi_test.out wa_deriv_mpi_test.out wa_integral_mpi_test.out \
	wa_interpolate00_mpi_test.out  \
	wa_spectrum_mpi_test.out wa_spectrum_mpi_module_test.out
	$(MPIRUN) ./wa_base_mpi_test.out
	$(MPIRUN) ./wa_deriv_mpi_test.out
	$(MPIRUN) ./wa_integral_mpi_test.out
	$(MPIRUN) ./wa_interpolate00_mpi_test.out
	$(MPIRUN) ./wa_spectrum_mpi_test.out
	$(MPIRUN) ./wa_spectrum_mpi_module_test.out

.SUFFIXES: .f90 .out

.f90.out:
	$(MPIFC) -I../../src -I../../src-mpi $(SYSFFLAGS) -o $@ $< -L../../src -l$(LIBNAME) $(SYSLDFLAGS) $(SYSLDLIBS)

=== debian/changelog ===
spml-g95 (0.7.1-1) unstable; urgency=low

  * New Upstream version 0.7.1
  * Update source format: 3.0 (quilt)

 -- Youhei SASAKI <uwabami@gfd-dennou.org>  Mon, 27 Feb 2012 15:08:54 +0000

=== debian/control ===
Source: spml-g95
Section: science
Priority: optional
Maintainer: Youhei SASAKI <uwabami@gfd-dennou.org>
Build-Depends: debhelper (>= 7.0.50~), autotools-dev, openmpi-g95, libnetcdff-g95-dev, gtool5-g95, libispack-g95-dev, liblapack-g95-dev, rdtool
Standards-Version: 3.9.2
Homepage: http://www.gfd-dennou.org/arch/spmodel

Package: spml-g95
Architecture: any
Conflicts: spml-lapack-g95 (<< 0.5.0-5)
Replaces: spml-lapack-g95 (<< 0.5.0-1)
Provides: spml-g95
Depends: ${shlibs:Depends}, ${misc:Depends}, netcdf-g95, gtool5-g95, ispack-g95, openmpi-g95, liblapack-g95-dev
Description: Fortran90 module library for solveing fundamental GFD problems
 SPML (a SPectral Model Library) is a Fortran90 module library for
 constructing spectral models for fundamental geophysical fluid
 dynamic problems. Fortran90 modules of this library are based on
 ISPACK (http://www.gfd-dennou.org/arch/ispack), which is also library
 for spectral models but written in Fortran77. This package provides
 module binary files built with G95 Fortran Compiler.

Package: spml-lapack-g95
Architecture: all
Depends: spml-g95
Description: Transitional package
 This dummy package is provided for a smooth transition from the
 previous spml-lapack-g95 package (the package is replaced by spml-g95).
 It may safely be removed after installation.

=== debian/rules ===
#!/usr/bin/make -f

FC:=/usr/bin/g95
MPIFC:=/usr/bin/mpif90.openmpi-g95
INCLUDE_FLAGS:= -I/usr/include/netcdf-g95
PACKAGE := spml-g95
# ARCH=$(shell dpkg --print-architecture)
FFLAGS:=-O2 -fPIC
SYSFFLAGS:=$(FFLAGS)
NETCDF:=/usr/lib/libnetcdf.a
NETCDFF:=/usr/lib/libnetcdff-g95.a
NETCDFINC:=/usr/include/netcdf-g95/netcdf.inc
GTOOL5:=/usr/lib/gtool5-g95/lib/libgtool5.a
GTOOL5_MPI:=/usr/lib/gtool5-g95-mpi/lib/libgtool5-mpi.a
ISPACK:=/usr/lib/libispack-g95.a
ISPACK_MPI:=/usr/lib/libispack-g95-mpi.a
# CONFIGURE
CONF_NETCDF:=--with-netcdf=$(NETCDF) \
	--with-netcdff=$(NETCDFF) \
	--with-netcdf-include=$(NETCDFINC)
CONF_GTOOL5:=--with-gtool5=$(GTOOL5)
CONF_GTOOL5_MPI:=--with-gtool5=$(GTOOL5_MPI)
CONF_ISPACK:=--with-ispack=$(ISPACK)
CONF_ISPACK_MPI:=--with-ispack=$(ISPACK_MPI)
CONF_LUMATRIX=--with-lapack=/usr/lib/liblapack-g95.a
# CONFIGURE
CONF_FLAGS:= $(CONF_NETCDF) \
	$(CONF_GTOOL5) \
	$(CONF_ISPACK) \
	$(CONF_LUMATRIX)
CONF_FLAGS_MPI:= $(CONF_NETCDF) \
	$(CONF_GTOOL5_MPI) \
	$(CONF_ISPACK_MPI) \
	$(CONF_LUMATRIX) \
	--with-mpifc=$(MPIFC)

MANPAGES:=debian/*.1

%:
	dh $@

override_dh_auto_configure:
override_dh_auto_test:

override_dh_prep:
	dh_prep -Xtmp

override_dh_auto_build:
	@echo "build non-mpi library"
	FC="$(FC)" SYSFFLAGS="$(SYSFFLAGS)" FFLAGS="$(FFLAGS)" \
	./configure --prefix=/usr/lib/$(PACKAGE) $(CONF_FLAGS)
	$(MAKE) LIBNAME=$(PACKAGE)
	$(MAKE) install \
		DESTDIR=$(CURDIR)/debian/tmp \
		LIBNAME=$(PACKAGE)
	$(MAKE) distclean
	@echo "build mpi library"
	FC="$(MPIFC)" SYSFFLAGS="$(SYSFFLAGS)" FFLAGS="$(FFLAGS)" \
	./configure --prefix=/usr/lib/$(PACKAGE)-mpi $(CONF_FLAGS_MPI)
	$(MAKE) LIBNAME=$(PACKAGE)
	$(MAKE) install \
		DESTDIR=$(CURDIR)/debian/tmp \
		LIBNAME=$(PACKAGE)
	$(MAKE) distclean

override_dh_installman:
	dh_installman $(MANPAGES)

override_dh_autoclean:
	dh_auto_clean
	-[ -f Config.mk ] && $(MAKE) distclean
